<script setup lang="ts">
    import { Compteur } from '@/interventionServiceOffer/entities/compteur/Compteur'
    import { CompteurApi } from '@/interventionServiceOffer/entities/compteur/CompteurApi'
    import { useMsal } from '@/plugins/msal/useMsal'
    import { emitSnackBar } from '@/plugins/snackBarManager'
    import SExpendableButton from '@/shared/button/components/SExpendableButton.vue'
    import {
        serviceOfferIdInjectionKey,
        serviceOfferTrackingCategoryInjectionKey,
    } from '@/shared/constants'
    import { getRelativeTimeString } from '@/shared/helpers/dates'
    import {
        isDefined,
        isUndefined,
        requiredInject,
    } from '@/shared/helpers/types'
    import { formatageDatePourAffichage } from '@/shared/helpers/dates'
    import Big from 'big.js'
    import { computed, ComputedRef, onBeforeUnmount, ref } from 'vue'
    import { getAnalyticsProvider } from '@/shared/analytics/AnalyticsProvider'
    import { useUserStore } from '@/shared/user/stores/UserStore'
    import { textFromNumericBooleanValue } from '@/shared/helpers/strings'
    import { Mesure } from '@/interventionServiceOffer/entities/mesure/Mesure'
    import { mesureMapper } from '@/interventionServiceOffer/entities/mesure/MesureMapper'
    import { getSérieDeValeurEntreDeuxEntiersInclus } from '@/shared/helpers/numbers'
    import { téléchargerFichierNommé } from '@/shared/helpers/files'
    import { RequestAborter } from '@/shared/api/entities/RequestAborter'
    import { SilabError } from '@/shared/errors/SilabError'

    const compteur = defineModel<Compteur>('compteur', { required: true })
    const nombreDeValeursDistinctesAPartirDuquelOnPréfèreLesBoutons = 4

    const msal = useMsal()
    const serviceOfferId = requiredInject(serviceOfferIdInjectionKey)
    const serviceOfferTrackingCategory = requiredInject(
        serviceOfferTrackingCategoryInjectionKey
    )
    const { currentUserHasRoleForServiceOffer } = useUserStore(msal)
    const lutilisateurPeutReleverDesCompteurs = computed(() => {
        return currentUserHasRoleForServiceOffer(
            'INTERVENTION_RELEVER_COMPTEUR',
            serviceOfferId.value
        )
    })

    const typeDInput: ComputedRef<
        'champ libre' | 'groupe de boutons' | 'booléen'
    > = computed(() => {
        if (compteur.value.type === 'boolean') {
            return 'booléen'
        }

        if (isUndefined(compteur.value.valeurMinimum)) {
            return 'champ libre'
        }

        if (isUndefined(compteur.value.valeurMaximum)) {
            return 'champ libre'
        }

        const nombreDeValeursDistinctes =
            compteur.value.valeurMaximum - compteur.value.valeurMinimum + 1
        if (
            compteur.value.type === 'integer' &&
            nombreDeValeursDistinctes <=
                nombreDeValeursDistinctesAPartirDuquelOnPréfèreLesBoutons
        ) {
            return 'groupe de boutons'
        }

        return 'champ libre'
    })

    const compteurApi = new CompteurApi(msal)
    const historiqueDesRelèvesAborter = new RequestAborter()
    const relèveEnCours = ref<boolean>(false)

    const mesure = ref<Partial<Mesure>>({
        valeur: compteur.value.derniereMesure?.valeur,
    })

    const valeurMesure = computed({
        get() {
            return mesure.value.valeur
        },
        set(valeurSaisie: number | string | undefined) {
            // les navigateurs renvoient une chaine de caractère vide si on ne rentre pas un nombre dans l'input.
            if (typeof valeurSaisie === 'number') {
                mesure.value = { valeur: valeurSaisie }
                return
            }
            mesure.value = { valeur: undefined }
        },
    })

    const formIsValid = ref<boolean>(false)
    const rules = {
        isNumber: (input: string | undefined | number) => {
            return (
                typeof input === 'number' ||
                'Veuillez renseigner une valeur numérique'
            )
        },
        isDefined: (input: number | undefined) => {
            return isDefined(input) || "Veuillez indiquer l'etat du compteur "
        },
    }
    const textInformationsSurDernièreMesure = computed(() => {
        if (isUndefined(compteur.value.derniereMesure)) {
            return
        }
        return compteur.value.type === 'boolean'
            ? `${compteur.value.unite} : ${textFromNumericBooleanValue(
                  compteur.value.derniereMesure.valeur
              )}`
            : `${compteur.value.derniereMesure.valeur} ${compteur.value.unite}`
    })
    const textInformationsSurMesureCourante = computed(() => {
        if (isUndefined(compteur.value.derniereMesure)) {
            return ''
        }
        if (isUndefined(mesure.value.valeur)) {
            return undefined
        }

        if (compteur.value.type === 'boolean') {
            return
        }

        const derniereValeur = compteur.value.derniereMesure.valeur

        const deltaValeur = Big(mesure.value.valeur)
            .minus(derniereValeur)
            .toNumber()

        const sign = deltaValeur >= 0 ? '+' : '-'

        return `${sign}${Math.abs(
            deltaValeur
        )} ${compteur.value.unite.toLowerCase()} en ${getRelativeTimeString(
            new Date(),
            compteur.value.derniereMesure.createdAt
        )}`
    })

    async function enregistreNouvelleMesure() {
        try {
            relèveEnCours.value = true
            const createMesureDto = mesureMapper.toCreateDto(mesure.value)
            const nouvelleMesure = await compteurApi.newMeasure(
                serviceOfferId.value,
                compteur.value.id,
                createMesureDto
            )
            getAnalyticsProvider().sendEvent(
                serviceOfferTrackingCategory.value,
                'Relève de compteur',
                `${compteur.value.label} ${compteur.value.code}`,
                nouvelleMesure.valeur
            )
            const messageSnackBar =
                compteur.value.type === 'boolean'
                    ? `${compteur.value.unite.toLocaleLowerCase()} : ${textFromNumericBooleanValue(
                          nouvelleMesure.valeur
                      )}, pour ${compteur.value.label}`
                    : `${
                          nouvelleMesure.valeur
                      } ${compteur.value.unite.toLocaleLowerCase()} de relevé sur ${
                          compteur.value.label
                      }`
            emitSnackBar(messageSnackBar, 'primary')
            compteur.value.derniereMesure = nouvelleMesure
        } catch (error) {
            emitSnackBar((<Error>error).message, 'error')
        } finally {
            relèveEnCours.value = false
        }
    }

    async function téléchargerHistoriqueDesRelèves() {
        historiqueDesRelèvesAborter.abortRequestsAndRefreshAborter()

        try {
            const fichierNomméHistorique =
                await compteurApi.getFichierHistoriqueDesRelèves(
                    serviceOfferId.value,
                    compteur.value.id,
                    historiqueDesRelèvesAborter.getSignal()
                )
            téléchargerFichierNommé(fichierNomméHistorique)
        } catch (error) {
            if ((<Error>error).name !== 'AbortError') {
                throw new SilabError((<Error>error).message, 'error')
            }
        }
    }

    onBeforeUnmount(() => {
        historiqueDesRelèvesAborter.abortRequestsAndRefreshAborter()
    })
</script>

<template>
    <template v-if="lutilisateurPeutReleverDesCompteurs">
        <v-card variant="flat" :data-cy="`compteur-${compteur.id}`">
            <v-card-title data-cy="compteur-titre" class="pb-0">
                {{ compteur.label }}
            </v-card-title>
            <v-card-subtitle>
                {{ compteur.code }}
            </v-card-subtitle>
            <v-card-text>
                <div class="d-flex flex-column">
                    <v-form
                        v-model="formIsValid"
                        class="d-inline-flex align-center"
                        @submit.prevent="enregistreNouvelleMesure"
                    >
                        <v-text-field
                            v-if="typeDInput === 'champ libre'"
                            v-model.number="valeurMesure"
                            :rules="[rules.isNumber]"
                            type="number"
                            :suffix="compteur.unite.toLowerCase()"
                            data-cy="valeur-compteur-float-relevee"
                            persistent-hint
                            :hint="textInformationsSurMesureCourante"
                            :hide-details="false"
                            style="min-width: 20em"
                            @focus="$event.target.select()"
                        >
                            <template #append-inner
                                ><s-expendable-button
                                    class="ml-2"
                                    icon="mdi-content-save"
                                    color="primary"
                                    label="Relever"
                                    data-cy="compteur-enregistrer-mesure"
                                    :loading="relèveEnCours"
                                    :disabled="!formIsValid"
                                    @click="enregistreNouvelleMesure"
                                >
                                </s-expendable-button
                            ></template>
                        </v-text-field>
                        <template v-if="typeDInput === 'booléen'">
                            <v-btn-toggle
                                v-model="valeurMesure"
                                divided
                                color="primary"
                                style="border: solid lightgray 1px"
                            >
                                <v-btn :value="0" :rounded="false">non</v-btn>
                                <v-btn :value="1" :rounded="false">oui</v-btn>
                            </v-btn-toggle>
                            <v-spacer />
                            <s-expendable-button
                                icon="mdi-content-save"
                                color="primary"
                                label="Relever"
                                data-cy="compteur-enregistrer-mesure"
                                :loading="relèveEnCours"
                                :disabled="isUndefined(valeurMesure)"
                                @click="enregistreNouvelleMesure"
                            >
                            </s-expendable-button>
                        </template>
                        <template
                            v-if="
                                typeDInput === 'groupe de boutons' &&
                                isDefined(compteur.valeurMaximum) &&
                                isDefined(compteur.valeurMinimum)
                            "
                        >
                            <v-btn-toggle
                                v-model="valeurMesure"
                                divided
                                color="primary"
                                style="border: solid lightgray 1px"
                            >
                                <v-btn
                                    v-for="valeurRelève in getSérieDeValeurEntreDeuxEntiersInclus(
                                        compteur.valeurMinimum,
                                        compteur.valeurMaximum
                                    )"
                                    :key="valeurRelève"
                                    :value="valeurRelève"
                                    :rounded="false"
                                >
                                    {{ valeurRelève }}
                                </v-btn>
                            </v-btn-toggle>
                            <v-spacer />
                            <s-expendable-button
                                icon="mdi-content-save"
                                color="primary"
                                label="Relever"
                                data-cy="compteur-enregistrer-mesure"
                                :loading="relèveEnCours"
                                :disabled="isUndefined(valeurMesure)"
                                @click="enregistreNouvelleMesure"
                            >
                            </s-expendable-button>
                        </template>
                    </v-form>
                    <span
                        v-if="compteur.derniereMesure"
                        data-cy="compteur-derniere-mesure"
                    >
                        Dernier relevé :
                        <strong>{{ textInformationsSurDernièreMesure }}</strong>
                        le
                        {{
                            formatageDatePourAffichage(
                                compteur.derniereMesure?.createdAt,
                                'minute'
                            )
                        }}
                    </span>
                    <span v-else data-cy="compteur-derniere-mesure">
                        <strong>Dernier relevé</strong> : <em>-aucun-</em>
                    </span>
                    <a
                        @click="téléchargerHistoriqueDesRelèves()"
                        class="cursor-pointer"
                    >
                        <v-icon color="primary">
                            mdi-file-download-outline
                        </v-icon>
                        Télécharger l'historique
                    </a>
                </div>
            </v-card-text>
        </v-card>
    </template>
    <v-card
        v-else
        variant="flat"
        density="compact"
        :data-cy="`compteur-read-only-${compteur.id}`"
    >
        <v-card-title> {{ compteur.label }} {{ compteur.code }} </v-card-title>

        <v-card-text
            v-if="isUndefined(compteur.derniereMesure)"
            data-cy="dernière-mesure"
        >
            Aucune mesure réalisée
        </v-card-text>
        <div v-else>
            <v-card-text data-cy="dernière-mesure" class="pt-1"
                ><strong v-if="compteur.type === 'float'">
                    {{ compteur.derniereMesure.valeur }}
                    {{ compteur.unite }}
                </strong>
                <strong v-else>
                    {{ compteur.unite }}
                    :
                    {{
                        textFromNumericBooleanValue(
                            compteur.derniereMesure.valeur
                        )
                    }}
                </strong>
                le
                {{
                    formatageDatePourAffichage(
                        compteur.derniereMesure.createdAt,
                        'minute'
                    )
                }}
            </v-card-text>
        </div>
    </v-card>
</template>
